function printf(...) if(qopqdp.master()) then io.write(string.format(...)) end end

nx = nx or 8
nt = nt or 8
res = res or 1e-6
m = 0.5
nm = 1
nsrc = 5
nrep = 1
u0 = 0.874164
f7lf = 0
opts = { prec=1, restart=1750 }

latsize = { nx, nx, nx, nt }
qopqdp.lattice(latsize)
qopqdp.profile(1)
qopqdp.verbosity(0)
qopqdp.seed(os.time())

printf("nm = %i\n", nm)
printf("nsrc = %i\n", nsrc)

g = qopqdp.gauge()
g:unit()
--g:random()

h = qopqdp.hisq()
--h:set(g, u0, f7lf, opts.prec)
h:set(g, u0, f7lf, 2)

src = {}
for i=1,nsrc do
  src[i] = h:quark()
  --src:point({0,0,0,0},0,1,0)
  src[i]:random()
end

soln = {}
for i=1,nm do soln[i] = h:quark() end


mmin = 4e-17
mmin = 4e-10
--mmin = m
ms = {}
while m>=mmin do
  ms[#ms+1] = m
  m = 0.5*m
end
ms[#ms+1] = ms[5]

for i=1,#ms do
  mm = {}
  for j=1,nm do mm[j] = j*ms[i] end

  --h = qopqdp.hisq()
  h:set(g, u0, f7lf, 2)
  printf("starting solve m = %g\n", mm[1])
  for r=1,nrep do
  for j=1,nsrc do

    for k=1,nm do soln[k]:zero() end
    t0 = qopqdp.dtime()
    h:solve(soln, src[j], mm, res, "even", opts)
    t0 = qopqdp.dtime() - t0
    cgt = h:time()
    cgf = h:flops()
    cgi = h:its()

    printf("its: %i\n", cgi)
    printf("time: %g\n", t0)
    printf("time: %g\n", cgt)
    printf("Mflops: %g\n", 1e-6*cgf/t0)
    printf("Mflops: %g\n", 1e-6*cgf/cgt)

  end
end
end
