require 'Util'

local transformmt = {}
transformmt._type = "Transform"
transformmt.__index = transformmt

function Transform(lattice, opts)
  local t = {}
  --t.parents = nil -- hash of [parent]=nupdate
  --t.filename = nil
  --t.metadata = nil
  if opts.kind == "gauge" then
    t.group = lattice.defaultGroup
    t.nc = lattice.defaultNc
  end
  tableCopyTo(t, opts)
  if t.kind == "gauge" then
    if t.momentum then
      t.transform = qopqdp.force(t.precision, t.nc, lattice.qdplat)
      t.name = "M" .. t.group .. t.nc
    else
      t.transform = qopqdp.gauge(t.precision, t.nc, lattice.qdplat)
      t.name = "GF" .. t.group .. t.nc
    end
  else
    --t.name = "F" .. opts.kind
    error(string.format("unknown Transform kind: %s\n", t.kind))
  end
  clearStats(f, "update")
  return setmetatable(f,transformmt)
end

function transformmt.__tostring(self)
  local s = {}
  tostringRecurse(s, self, {self.lattice})
  if s.done then return "" end
  s[#s+1] = self.name
  s[#s+1] = " = "
  s[#s+1] = self.lattice.name
  s[#s+1] = ":Transform {\n"
  s[#s+1] = string.format("  group = \"%s\",\n",self.group)
  s[#s+1] = string.format("  nc = %g\n",self.nc)
  s[#s+1] = "}\n"
  return table.concat(s)
end

