require 'Vector'

function getCycle(ls, v)
  local nd = #v
  local x = {}
  for i=1,nd do x[i] = 0 end
  local c = 1
  while true do
    local nonzero = false
    for i=1,nd do
      x[i] = (x[i]+v[i]) % ls[i]
      nonzero = nonzero or (x[i] ~= 0)
    end
    if not nonzero then break end
    c = c + 1
  end
  myprint(v, " : ", c, "\n")
  return c
end

function makeMoms(ls, mb)
  local nd = #ls
  local lb,cb = {},{}
  local cv = 1
  for i=1,#mb do
    lb[i] = Vector.lexIndex(ls,mb[i])
    cb[i] = getCycle(ls,mb[i])
    cv = cv * cb[i]
  end
  local ml,ll,nl = {},{},0
  for i=0,cv-1 do
    local p = Vector.zero(nd)
    local j,k = 1,i
    while k>0 do
      local s = k%cb[j]
      for l=1,#p do p[l] = (p[l] + s*mb[j][l])%ls[l] end
      k = math.floor(k/cb[j])
      j = j + 1
    end
    local l = Vector.lexIndex(ls,p)
    local found = false
    for n=1,nl do
      if l==ll[n] then found=true; break end
    end
    if not found then  
      nl = nl + 1
      ml[nl] = p
      ll[nl] = l
    end
  end
  return ml
end

nx = 64
nt = 128
nd = 4

ls = Vector{}
for i=1,nd-1 do ls[i] = nx end
ls[nd] = nt
vol = 1
for i=1,#ls do vol = vol * ls[i] end



function distance(v)
  local d = 0
  for i=1,#v do d = d + math.abs(v[i]) end
  return d
end

local xmax = {}
local dmax = {}
for i=1,#ls do xmax[i],dmax[i] = 0,0 end

for i=1,nd do
  while dmax[i] < d
addPoints(xmax, dmax)
d = 0




os.exit(1)

--e = Vector.standardBasis(nd)
--basis = {e[1]+e[2],e[1]+e[3],e[1]+e[4]}
--myprint(basis[1], "\n")
--myprint(basis[2], "\n")
--myprint(basis[1]+basis[2], "\n")
--moms = { {0,0,0}, {1,1,1}}
--moms = { {0,0,0}, {0,1,1}, {1,0,1}, {1,1,0}}
--moms = {{0,0,0,0},{1,1,1,1}}
--moms = {{0,0,0,0},{0,0,1,1},{1,1,0,0},{1,1,1,1}}
--moms = {{0,0,0,0},{0,1,1,0},{1,0,1,1},{1,1,0,1}}
--mombasis = {{1,1},{0,1}}
--mombasis = {{1,2},{0,1}}
--mombasis = {{2,2,3},{0,0,1},{1,1,0}}
mombasis = {{0,0,0,64},{32,32,32,64},{0,0,32,0},{0,32,0,0},{0,0,0,32},{0,0,16,0},{0,16,0,0},{16,0,0,0}}

ml = makeMoms(ls, mombasis)

for i=1,#ml do
  myprint(i, " : ", ml[i], "\n")
end

os.exit(1)


local s0 = {}
for i=1,#ls do s0[i] = 2*math.pi/ls[i] end

for i=0,vol-1 do
  local x = lexCoord(ls, i)
  local r = 0
  for j=1,#moms do
    local m = moms[j]
    local px = 0
    for k=1,#m do
      px = px + s0[k]*m[k]*x[k]
    end
    r = r + complex(math.cos(px),math.sin(px))
  end
  myprint(i, ": ", x, r, "\n")
end
